#   Copyright and License: see LICENSE file
#
#   Contributors:
#          * Joachim Baran

class Synchronization
  include Singleton

  def initialize
    @internalMutex = Mutex.new()
    @mutexes = {}
  end

  def lock(id)
    mutex = nil
    @internalMutex.synchronize {
      mutex = @mutexes[id]
      unless mutex then
        mutex = Mutex.new()
        @mutexes[id] = mutex
      end
    }
    mutex.lock
  end

  def unlock(id)
    @internalMutex.synchronize {
      @mutexes[id].unlock
    }
  end
end

