#   Copyright and License: see LICENSE file
#
#   Contributors:
#	   * Joachim Baran

class DispatcherHTTP
  def dispatch()
    Log.instance.log('dispatch() reached')
    if FASTCGI then
      Log.instance.log('Waiting for requests...')
      FCGI.each { |request|
        Log.instance.log('Incoming request...')

        handle(request)
        request.finish
      }
    else
      # DEFUNCT
      Log.instance.log('Uhm.. we don\'t do CGI anymore. Only FastCGI is supported now.')
    end
  end

  private

  def handle(fcgi)
    request = nil
    session_id = nil

    request = fcgi.in.read

    cookies = fcgi.env['HTTP_COOKIE']
    session_id = CGI::Cookie::parse(cookies)['session'] if cookies

    # Get the string representation of the session ID:
    session_id = session_id[0] if session_id

    if session_id then
      Log.instance.log('Session: ' << session_id)
      Log.instance.log('Type: ' << session_id.class.to_s)
    else
      Log.instance.log('Session: -')
    end
    Log.instance.log('Request: ' << request)

    interpreter = InterpreterJSON.new()
    result = interpreter.execute(session_id, request)
    
    Log.instance.log('JSON Result: ' << result.to_s)

    fcgi.out.print("Content-Type: text/plain\r\n")
    if result['session'] then
      session_cookie = CGI::Cookie.new("session", result['session']);
      fcgi.out.print("Set-Cookie: #{session_cookie}\r\n")
    end
    fcgi.out.print("\r\n")
    fcgi.out.print(result['response'])
  end
end
